#!/usr/bin/python

## In bash we can simply use the following:
##    if ! test -f build-number.txt; then echo 0 > build-number.txt; fi
##    echo $(($(cat build-number.txt) + 1)) > build-number.txt
## 
## We can also embed the above in the makefile :
##   $(BUILD_NUMBER_FILE): $(OBJECTS)
##      @if ! test -f $(BUILD_NUMBER_FILE); then echo 0 > $(BUILD_NUMBER_FILE); fi
##      @echo $$(($$(cat $(BUILD_NUMBER_FILE)) + 1)) > $(BUILD_NUMBER_FILE)
##
## Consider : use json
## Consider : use pickle module
##   f is a file object which has been opened for reading:
##   pickle.dump(x, f)
##   x = pickle.load(f)

import re
import os
import sys

def main(argv=None) :
  if argv is None : argv = sys.argv ; 
  argv = argv[1:] ;     ## skip over argv[0] 
  f = None ; 
  DotFile = "./.dot" 
  try : 
    ## use: r+ ; w ; a ; a+
    f = open (DotFile, "r+") ; 
    f.seek (0,0) ; 
  except :
    f = open (DotFile, "a+") ; 
    pass ; 
  if False : print f ; 
  vers = f.readline() ; 
  if False : print "Version=" + vers ; 
  if vers == "" :
    vers = "0" ; 
  else : 
    vers = vers.split()[6]; 
    vers = str(int(vers)+1) ; 
  f.seek (0,0) ; 
  f.write ("static const unsigned int BuildSeq = " + vers + " ;\n") ; 
  ## f.truncate () ; 
  ## f.flush () ; 
  f.close () ; 
  print "Version=" + vers ; 
  


if __name__ == "__main__":
  sys.exit(main()) ;
